unit MyLibrary;

{$mode objfpc}{$H+}

{*******************************************************************************
*          Library code for accessing Lazarus LCL Objects in a DLL             *
*                                                                              *
*          Latest changes:  2012-01-04   by Breakoutbox                        *
********************************************************************************
* Hints:                                                                       *
*   -  We can't use the whole LCL here - please see remarks in USES section    *
*******************************************************************************}

interface

uses
  Classes,
  //LCLintf requires:  $(LazarusDir)\lcl\units\$(TargetCPU)-$(TargetOS)
  //LCLintf, // => mylibrary.pas(1,1) Fatal: Can't find unit FileUtil used by LCLProc
  //StdCtrls, => also does not compile
  rwincontrol,
  rwincontrolclient;


//------------------------------------------------------------------------------
//  The following functions do create Example Buttons, Labels etc.
//  Here we only create the Objects, set the Parent and other Properties.
//  After this You can access the Object's properties
//  and methods from Your Main Application as usual.
//------------------------------------------------------------------------------

function CreateBtn( intr:TRWinControlInterface; aParent:TRHandle):TRHandle;
function CreateLbl( intr:TRWinControlInterface; Parent:TRHandle):TRHandle;


implementation

function CreateBtn( intr:TRWinControlInterface; aParent:TRHandle):TRHandle; //not stdcall;   ?
begin
  RProcessInterface( intr);
  result:= RCreate( StrToRstr( 'TButton'));
  RSetStrProp( result, StrToRstr( 'Caption'), StrToRstr( 'Hello world !'));
  RSetIntProp( result, StrToRstr( 'Left'), 10);
  RSetIntProp( result, StrToRstr( 'Top'), 30);
  RSetParent( result, aParent);  // Parent is a Panel, in this example ..
end;

function CreateLbl( intr:TRWinControlInterface; Parent:TRHandle):TRHandle; //not stdcall;   ?
begin
  RProcessInterface( intr);
  result:= RCreate( StrToRstr( 'TLabel'));
  RSetStrProp( result, StrToRstr( 'Caption'), StrToRstr( 'Hel'+#0+'lo !'));
  RSetIntProp( result, StrToRstr( 'Left'), 10);
  RSetIntProp( result, StrToRstr( 'Top'), 10);
  RSetIntProp( result, StrToRstr( 'Width'), 100);
  RSetIntProp( result, StrToRstr( 'Height'), 24);
  RSetParent( result, Parent);
end;


// -----------------------------------------------------------------------------
//       export all functions we want to be published by the DLL :
// -----------------------------------------------------------------------------
exports CreateBtn;
exports CreateLbl;


end.

