unit rwincontrol;

{$mode objfpc}{$H+}

{*******************************************************************************
*  == LICENSE ==                                                               *
*  (C) 2009 Covac Software. You may copy, store, modify and sell this software *
*      as long as you keep copyright comments in the source code.              *
*******************************************************************************}

{$DEFINE USE_BIN_STR}   // binary strings are much slower - but they
                        // allow binary content, up to 2 GB.
                        // Deactivate this if You want to use PHAR instead !

interface

uses
  Classes, SysUtils;

type
  {$IFDEF USE_BIN_STR}
    TRString=interface
      function Length: Integer; stdcall;
      function Text: PChar; stdcall;
    end;
    TRStringImp=class(TInterfacedObject, TRString)
      private
        FText: String;
        function Length: Integer; stdcall;
        function Text: PChar; stdcall;
      public
        constructor Create(AString: String);
    end;
  {$ELSE}
    TRString=PChar;    // just an alias
  {$ENDIF}
  TRHandle=Pointer;
  TRProperty=record
    Setter:Pointer;
    Getter:Pointer;
  end;
  TRMethod=TRHandle;
  TRWinControlInterface=record
    // main/spacial methods
    Create:TRMethod;
    Free:  TRMethod;
    // core property management
    StrProp:TRProperty;
    IntProp:TRProperty;
    ObjProp:TRProperty;
    SetProp:TRProperty;
    // quick access
    Parent:TRProperty;
  end;

function StrToRstr(Value:String):TRString;
function RstrToStr(const Value:TRString):String;


implementation

function StrToRstr(Value:String):TRString;
begin
  {$IFDEF USE_BIN_STR}
  Result:= TRStringImp.Create(Value);
  {$ELSE}
  Result:= PChar(Value);
  {$ENDIF}
end;

function RstrToStr(const Value:TRString):String;
begin
  {$IFDEF USE_BIN_STR}
  if (Value.Length>0)and(Value.Text<>nil) then begin
    SetLength(Result,Value.Length);
    Move(Value.Text^,Result[1],Value.Length);
  end else Result:='';
  // i even think Result := Value.Text will work
  {$ELSE}
  Result:=Value;
  {$ENDIF}
end;

{$IFDEF USE_BIN_STR}
function TRStringImp.Length: Integer; stdcall;
begin
  Result:= System.Length(FText);
end;

function TRStringImp.Text: PChar; stdcall;
begin
  Result:= PChar(FText);
end;

constructor TRStringImp.Create(AString: String);
begin
  inherited Create;
  FText := AString;
end;
{$ENDIF}

end.

