unit rwincontrolserver;

{$mode objfpc}{$H+}

{*******************************************************************************
*  == LICENSE ==                                                               *
*  (C) 2009 Covac Software. You may copy, store, modify and sell this software *
*      as long as you keep copyright comments in the source code.              *
*******************************************************************************}

interface

uses
  Classes, SysUtils, controls, rwincontrol, typinfo;


function FillRWinControlInterface : TRWinControlInterface;


implementation

// interface functions
function RCreate( ClassName:TRString):TRHandle;
begin
  try
    Result:= TRHandle( TComponentClass( FindClass( RstrToStr( ClassName))).Create( nil));
  except
    Result:= nil;
  end;
end;

procedure RFree(Handle:TRHandle);
begin
  TWinControl( Handle).Free;
end;

procedure RSetParent(Handle:TRHandle; Parent:TRHandle);
begin
  TWinControl( Handle).Parent:= TWinControl( Parent);
end;

function RGetParent(Handle:TRHandle):TRHandle;
begin
  try
    Result:= TRHandle( TWinControl( Handle).Parent);
  except
    Result:= nil;
  end;
end;

procedure RSetStrProp(Handle:TRHandle; Prop:TRString; Value:TRString);
begin
  // todo: do some checking
  SetStrProp( TWinControl( Handle), RstrToStr( Prop), RstrToStr( Value));
end;

function RGetStrProp(Handle:TRHandle; Prop:TRString):TRString;
begin
  try
    Result:= StrToRstr( GetStrProp( TWinControl( Handle), RstrToStr( Prop)));
  except
    Result:= StrToRstr( '');
  end;
end;

procedure RSetIntProp(Handle:TRHandle; Prop:TRString; Value:Integer);
begin
  // todo: do some checking
  SetInt64Prop(TWinControl(Handle),RstrToStr(Prop),Value);
end;

function RGetIntProp(Handle:TRHandle; Prop:TRString):Integer;
begin
  try
    Result:= GetInt64Prop( TWinControl( Handle), RstrToStr( Prop));
  except
    Result:= 0;
  end;
end;

procedure RSetObjProp(Handle:TRHandle; Prop:TRString; Value:TRHandle);
begin
  // todo: do some checking
  SetObjectProp( TWinControl( Handle), RstrToStr( Prop), TObject( Value));
end;

function RGetObjProp(Handle:TRHandle; Prop:TRString):TRHandle;
begin
  try
    Result:= TRHandle( GetObjectProp( TWinControl( Handle), RstrToStr( Prop)));
  except
    Result:= nil;
  end;
end;

// initialization function
function FillRWinControlInterface:TRWinControlInterface;
begin
  // main routines
  Result.Create:= TRMethod( @RCreate);
  Result.Free:= TRMethod( @RFree);
  // core property management (TRString)
  Result.StrProp.Getter:= TRMethod( @RGetStrProp);
  Result.StrProp.Setter:= TRMethod( @RSetStrProp);
  // core property management (Int64)
  Result.IntProp.Getter:= TRMethod( @RGetIntProp);
  Result.IntProp.Setter:= TRMethod( @RSetIntProp);
  // core property management (TRHandle)
  Result.ObjProp.Getter:= TRMethod( @RGetObjProp);
  Result.ObjProp.Setter:= TRMethod( @RSetObjProp);
  //SetProp
  // quick access
  Result.Parent.Getter:= TRMethod( @RGetParent);
  Result.Parent.Setter:= TRMethod( @RSetParent);
end;


end.

